import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import plugin from "@start/plugin";
import optionsToArgs from "./optionsToArgs";
export default ((outDirRelative, userOptions) => plugin('typescriptGenerate',
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(function* ({
    files,
    logFile
  }) {
    const path = yield import('path');

    const _ref2 = yield import('execa'),
          execa = _ref2.default;

    const _ref3 = yield import('move-path'),
          movePath = _ref3.default;

    const tscBinPath = path.resolve('node_modules/.bin/tsc');
    const spawnOptions = {
      stripEof: false,
      env: {
        FORCE_COLOR: '1'
      }
    };
    return {
      files: yield Promise.all(files.map(
      /*#__PURE__*/
      function () {
        var _ref4 = _asyncToGenerator(function* (file) {
          const outDir = path.dirname(movePath(file.path, outDirRelative));

          const options = _objectSpread({
            allowSyntheticDefaultImports: true,
            lib: 'esnext',
            moduleResolution: 'node'
          }, userOptions, {
            declarationDir: outDir,
            emitDeclarationOnly: true,
            declaration: true
          });

          const tscArgs = optionsToArgs(options);

          try {
            yield execa(tscBinPath, [...tscArgs, file.path], spawnOptions);
          } catch (e) {
            throw null;
          }

          const dtsFilename = `${path.basename(file.path, '.ts')}.d.ts`;
          const dtsPath = path.resolve(outDir, dtsFilename);
          logFile(dtsPath);
          return {
            path: dtsPath,
            data: null,
            map: null
          };
        });

        return function (_x2) {
          return _ref4.apply(this, arguments);
        };
      }()))
    };
  });

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}()));